// File: std/stl_function.cpp
#include <functional> // std::binary_function
#include <functional> // std::equal_to
#include <sstream> // __str__

#include <functional>
#include <pybind11/pybind11.h>
#include <string>

#ifndef BINDER_PYBIND11_TYPE_CASTER
	#define BINDER_PYBIND11_TYPE_CASTER
	PYBIND11_DECLARE_HOLDER_TYPE(T, std::shared_ptr<T>)
	PYBIND11_DECLARE_HOLDER_TYPE(T, T*)
	PYBIND11_MAKE_OPAQUE(std::shared_ptr<void>)
#endif

void bind_std_stl_function(std::function< pybind11::module &(std::string const &namespace_) > &M)
{
	{ // std::binary_function file:bits/stl_function.h line:
		pybind11::class_<std::binary_function<float,float,bool>, std::shared_ptr<std::binary_function<float,float,bool>>> cl(M("std"), "binary_function_float_float_bool_t", "");
		cl.def( pybind11::init( [](std::binary_function<float,float,bool> const &o){ return new std::binary_function<float,float,bool>(o); } ) );
		cl.def( pybind11::init( [](){ return new std::binary_function<float,float,bool>(); } ) );
		cl.def("assign", (struct std::binary_function<float, float, bool> & (std::binary_function<float,float,bool>::*)(const struct std::binary_function<float, float, bool> &)) &std::binary_function<float, float, bool>::operator=, "C++: std::binary_function<float, float, bool>::operator=(const struct std::binary_function<float, float, bool> &) --> struct std::binary_function<float, float, bool> &", pybind11::return_value_policy::automatic, pybind11::arg(""));
	}
	{ // std::equal_to file:bits/stl_function.h line:
		pybind11::class_<std::equal_to<float>, std::shared_ptr<std::equal_to<float>>, std::binary_function<float,float,bool>> cl(M("std"), "equal_to_float_t", "");
		cl.def( pybind11::init( [](){ return new std::equal_to<float>(); } ) );
		cl.def("__call__", (bool (std::equal_to<float>::*)(const float &, const float &) const) &std::equal_to<float>::operator(), "C++: std::equal_to<float>::operator()(const float &, const float &) const --> bool", pybind11::arg("__x"), pybind11::arg("__y"));
		cl.def("assign", (struct std::binary_function<float, float, bool> & (std::binary_function<float,float,bool>::*)(const struct std::binary_function<float, float, bool> &)) &std::binary_function<float, float, bool>::operator=, "C++: std::binary_function<float, float, bool>::operator=(const struct std::binary_function<float, float, bool> &) --> struct std::binary_function<float, float, bool> &", pybind11::return_value_policy::automatic, pybind11::arg(""));
	}
}


// File: std/functional_hash.cpp
#include <deque> // std::deque
#include <forward_list> // std::forward_list
#include <functional> // std::hash
#include <functional> // std::less
#include <list> // std::list
#include <map> // std::_Rb_tree_const_iterator
#include <memory> // std::allocator
#include <set> // std::set
#include <sstream> // __str__
#include <utility> // std::pair
#include <vector> // std::vector

#include <functional>
#include <pybind11/pybind11.h>
#include <string>

#ifndef BINDER_PYBIND11_TYPE_CASTER
	#define BINDER_PYBIND11_TYPE_CASTER
	PYBIND11_DECLARE_HOLDER_TYPE(T, std::shared_ptr<T>)
	PYBIND11_DECLARE_HOLDER_TYPE(T, T*)
	PYBIND11_MAKE_OPAQUE(std::shared_ptr<void>)
#endif

void bind_std_functional_hash(std::function< pybind11::module &(std::string const &namespace_) > &M)
{
	{ // std::hash file:bits/functional_hash.h line:
		pybind11::class_<std::hash<float>, std::shared_ptr<std::hash<float>>> cl(M("std"), "hash_float_t", "");
		cl.def( pybind11::init( [](){ return new std::hash<float>(); } ) );
		cl.def( pybind11::init( [](std::hash<float> const &o){ return new std::hash<float>(o); } ) );
		cl.def("__call__", (std::size_t (std::hash<float>::*)(float) const) &std::hash<float>::operator(), "C++: std::hash<float>::operator()(float) const --> std::size_t", pybind11::arg("__val"));
		cl.def("assign", (struct std::hash<float> & (std::hash<float>::*)(const struct std::hash<float> &)) &std::hash<float>::operator=, "C++: std::hash<float>::operator=(const struct std::hash<float> &) --> struct std::hash<float> &", pybind11::return_value_policy::automatic, pybind11::arg(""));
	}
	{ // std::set file:bits/stl_set.h line:
		pybind11::class_<std::set<float>, std::shared_ptr<std::set<float>>> cl(M("std"), "set_float_t", "");
		cl.def( pybind11::init( [](){ return new std::set<float>(); } ) );
		cl.def( pybind11::init( [](const struct std::less<float> & a0){ return new std::set<float>(a0); } ), "doc" , pybind11::arg("__comp"));
		cl.def( pybind11::init<const struct std::less<float> &, const class std::allocator<float> &>(), pybind11::arg("__comp"), pybind11::arg("__a") );

		cl.def( pybind11::init( [](std::set<float> const &o){ return new std::set<float>(o); } ) );
		cl.def("assign", (class std::set<float, struct std::less<float>, class std::allocator<float> > & (std::set<float>::*)(const class std::set<float, struct std::less<float>, class std::allocator<float> > &)) &std::set<float>::operator=, "C++: std::set<float>::operator=(const class std::set<float, struct std::less<float>, class std::allocator<float> > &) --> class std::set<float, struct std::less<float>, class std::allocator<float> > &", pybind11::return_value_policy::automatic, pybind11::arg("__x"));
		cl.def("key_comp", (struct std::less<float> (std::set<float>::*)() const) &std::set<float>::key_comp, "C++: std::set<float>::key_comp() const --> struct std::less<float>");
		cl.def("value_comp", (struct std::less<float> (std::set<float>::*)() const) &std::set<float>::value_comp, "C++: std::set<float>::value_comp() const --> struct std::less<float>");
		cl.def("get_allocator", (class std::allocator<float> (std::set<float>::*)() const) &std::set<float>::get_allocator, "C++: std::set<float>::get_allocator() const --> class std::allocator<float>");
		cl.def("empty", (bool (std::set<float>::*)() const) &std::set<float>::empty, "C++: std::set<float>::empty() const --> bool");
		cl.def("size", (unsigned long (std::set<float>::*)() const) &std::set<float>::size, "C++: std::set<float>::size() const --> unsigned long");
		cl.def("max_size", (unsigned long (std::set<float>::*)() const) &std::set<float>::max_size, "C++: std::set<float>::max_size() const --> unsigned long");
		cl.def("swap", (void (std::set<float>::*)(class std::set<float, struct std::less<float>, class std::allocator<float> > &)) &std::set<float>::swap, "C++: std::set<float>::swap(class std::set<float, struct std::less<float>, class std::allocator<float> > &) --> void", pybind11::arg("__x"));
		cl.def("insert", (struct std::pair<struct std::_Rb_tree_const_iterator<float>, bool> (std::set<float>::*)(const float &)) &std::set<float>::insert, "C++: std::set<float>::insert(const float &) --> struct std::pair<struct std::_Rb_tree_const_iterator<float>, bool>", pybind11::arg("__x"));
		cl.def("erase", (unsigned long (std::set<float>::*)(const float &)) &std::set<float>::erase, "C++: std::set<float>::erase(const float &) --> unsigned long", pybind11::arg("__x"));
		cl.def("clear", (void (std::set<float>::*)()) &std::set<float>::clear, "C++: std::set<float>::clear() --> void");
		cl.def("count", (unsigned long (std::set<float>::*)(const float &) const) &std::set<float>::count, "C++: std::set<float>::count(const float &) const --> unsigned long", pybind11::arg("__x"));
		cl.def("equal_range", (struct std::pair<struct std::_Rb_tree_const_iterator<float>, struct std::_Rb_tree_const_iterator<float> > (std::set<float>::*)(const float &)) &std::set<float>::equal_range, "C++: std::set<float>::equal_range(const float &) --> struct std::pair<struct std::_Rb_tree_const_iterator<float>, struct std::_Rb_tree_const_iterator<float> >", pybind11::arg("__x"));
	}
	{ // std::set file:bits/stl_set.h line:
		pybind11::class_<std::set<std::list<std::forward_list<std::deque<std::vector<double>>>>>, std::shared_ptr<std::set<std::list<std::forward_list<std::deque<std::vector<double>>>>>>> cl(M("std"), "set_std_list_std_forward_list_std_deque_std_vector_double_t", "");
		cl.def( pybind11::init( [](){ return new std::set<std::list<std::forward_list<std::deque<std::vector<double>>>>>(); } ) );
		cl.def( pybind11::init( [](const struct std::less<class std::list<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > >, class std::allocator<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > > > > > & a0){ return new std::set<std::list<std::forward_list<std::deque<std::vector<double>>>>>(a0); } ), "doc" , pybind11::arg("__comp"));
		cl.def( pybind11::init<const struct std::less<class std::list<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > >, class std::allocator<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > > > > > &, const class std::allocator<class std::list<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > >, class std::allocator<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > > > > > &>(), pybind11::arg("__comp"), pybind11::arg("__a") );

		cl.def( pybind11::init( [](std::set<std::list<std::forward_list<std::deque<std::vector<double>>>>> const &o){ return new std::set<std::list<std::forward_list<std::deque<std::vector<double>>>>>(o); } ) );
		cl.def("assign", (class std::set<class std::list<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > >, class std::allocator<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > > > >, struct std::less<class std::list<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > >, class std::allocator<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > > > > >, class std::allocator<class std::list<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > >, class std::allocator<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > > > > > > & (std::set<std::list<std::forward_list<std::deque<std::vector<double>>>>>::*)(const class std::set<class std::list<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > >, class std::allocator<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > > > >, struct std::less<class std::list<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > >, class std::allocator<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > > > > >, class std::allocator<class std::list<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > >, class std::allocator<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > > > > > > &)) &std::set<std::list<std::forward_list<std::deque<std::vector<double>>>>>::operator=, "C++: std::set<std::list<std::forward_list<std::deque<std::vector<double>>>>>::operator=(const class std::set<class std::list<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > >, class std::allocator<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > > > >, struct std::less<class std::list<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > >, class std::allocator<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > > > > >, class std::allocator<class std::list<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > >, class std::allocator<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > > > > > > &) --> class std::set<class std::list<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > >, class std::allocator<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > > > >, struct std::less<class std::list<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > >, class std::allocator<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > > > > >, class std::allocator<class std::list<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > >, class std::allocator<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > > > > > > &", pybind11::return_value_policy::automatic, pybind11::arg("__x"));
		cl.def("key_comp", (struct std::less<class std::list<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > >, class std::allocator<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > > > > > (std::set<std::list<std::forward_list<std::deque<std::vector<double>>>>>::*)() const) &std::set<std::list<std::forward_list<std::deque<std::vector<double>>>>>::key_comp, "C++: std::set<std::list<std::forward_list<std::deque<std::vector<double>>>>>::key_comp() const --> struct std::less<class std::list<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > >, class std::allocator<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > > > > >");
		cl.def("value_comp", (struct std::less<class std::list<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > >, class std::allocator<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > > > > > (std::set<std::list<std::forward_list<std::deque<std::vector<double>>>>>::*)() const) &std::set<std::list<std::forward_list<std::deque<std::vector<double>>>>>::value_comp, "C++: std::set<std::list<std::forward_list<std::deque<std::vector<double>>>>>::value_comp() const --> struct std::less<class std::list<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > >, class std::allocator<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > > > > >");
		cl.def("get_allocator", (class std::allocator<class std::list<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > >, class std::allocator<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > > > > > (std::set<std::list<std::forward_list<std::deque<std::vector<double>>>>>::*)() const) &std::set<std::list<std::forward_list<std::deque<std::vector<double>>>>>::get_allocator, "C++: std::set<std::list<std::forward_list<std::deque<std::vector<double>>>>>::get_allocator() const --> class std::allocator<class std::list<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > >, class std::allocator<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > > > > >");
		cl.def("empty", (bool (std::set<std::list<std::forward_list<std::deque<std::vector<double>>>>>::*)() const) &std::set<std::list<std::forward_list<std::deque<std::vector<double>>>>>::empty, "C++: std::set<std::list<std::forward_list<std::deque<std::vector<double>>>>>::empty() const --> bool");
		cl.def("size", (unsigned long (std::set<std::list<std::forward_list<std::deque<std::vector<double>>>>>::*)() const) &std::set<std::list<std::forward_list<std::deque<std::vector<double>>>>>::size, "C++: std::set<std::list<std::forward_list<std::deque<std::vector<double>>>>>::size() const --> unsigned long");
		cl.def("max_size", (unsigned long (std::set<std::list<std::forward_list<std::deque<std::vector<double>>>>>::*)() const) &std::set<std::list<std::forward_list<std::deque<std::vector<double>>>>>::max_size, "C++: std::set<std::list<std::forward_list<std::deque<std::vector<double>>>>>::max_size() const --> unsigned long");
		cl.def("swap", (void (std::set<std::list<std::forward_list<std::deque<std::vector<double>>>>>::*)(class std::set<class std::list<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > >, class std::allocator<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > > > >, struct std::less<class std::list<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > >, class std::allocator<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > > > > >, class std::allocator<class std::list<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > >, class std::allocator<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > > > > > > &)) &std::set<std::list<std::forward_list<std::deque<std::vector<double>>>>>::swap, "C++: std::set<std::list<std::forward_list<std::deque<std::vector<double>>>>>::swap(class std::set<class std::list<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > >, class std::allocator<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > > > >, struct std::less<class std::list<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > >, class std::allocator<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > > > > >, class std::allocator<class std::list<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > >, class std::allocator<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > > > > > > &) --> void", pybind11::arg("__x"));
		cl.def("clear", (void (std::set<std::list<std::forward_list<std::deque<std::vector<double>>>>>::*)()) &std::set<std::list<std::forward_list<std::deque<std::vector<double>>>>>::clear, "C++: std::set<std::list<std::forward_list<std::deque<std::vector<double>>>>>::clear() --> void");
	}
}


// File: std/unordered_set.cpp
#include <functional> // std::equal_to
#include <functional> // std::hash
#include <memory> // std::allocator
#include <sstream> // __str__
#include <unordered_map> // std::__detail::_Node_const_iterator
#include <unordered_map> // std::__detail::_Node_iterator
#include <unordered_set> // std::unordered_set
#include <utility> // std::pair

#include <functional>
#include <pybind11/pybind11.h>
#include <string>

#ifndef BINDER_PYBIND11_TYPE_CASTER
	#define BINDER_PYBIND11_TYPE_CASTER
	PYBIND11_DECLARE_HOLDER_TYPE(T, std::shared_ptr<T>)
	PYBIND11_DECLARE_HOLDER_TYPE(T, T*)
	PYBIND11_MAKE_OPAQUE(std::shared_ptr<void>)
#endif

void bind_std_unordered_set(std::function< pybind11::module &(std::string const &namespace_) > &M)
{
	{ // std::unordered_set file:bits/unordered_set.h line:
		pybind11::class_<std::unordered_set<float>, std::shared_ptr<std::unordered_set<float>>> cl(M("std"), "unordered_set_float_t", "");
		cl.def( pybind11::init( [](){ return new std::unordered_set<float>(); } ), "doc" );
		cl.def( pybind11::init( [](unsigned long const & a0){ return new std::unordered_set<float>(a0); } ), "doc" , pybind11::arg("__n"));
		cl.def( pybind11::init( [](unsigned long const & a0, const struct std::hash<float> & a1){ return new std::unordered_set<float>(a0, a1); } ), "doc" , pybind11::arg("__n"), pybind11::arg("__hf"));
		cl.def( pybind11::init( [](unsigned long const & a0, const struct std::hash<float> & a1, const struct std::equal_to<float> & a2){ return new std::unordered_set<float>(a0, a1, a2); } ), "doc" , pybind11::arg("__n"), pybind11::arg("__hf"), pybind11::arg("__eql"));
		cl.def( pybind11::init<unsigned long, const struct std::hash<float> &, const struct std::equal_to<float> &, const class std::allocator<float> &>(), pybind11::arg("__n"), pybind11::arg("__hf"), pybind11::arg("__eql"), pybind11::arg("__a") );

		cl.def( pybind11::init( [](std::unordered_set<float> const &o){ return new std::unordered_set<float>(o); } ) );
		cl.def("assign", (class std::unordered_set<float, struct std::hash<float>, struct std::equal_to<float>, class std::allocator<float> > & (std::unordered_set<float>::*)(const class std::unordered_set<float, struct std::hash<float>, struct std::equal_to<float>, class std::allocator<float> > &)) &std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::operator=, "C++: std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::operator=(const class std::unordered_set<float, struct std::hash<float>, struct std::equal_to<float>, class std::allocator<float> > &) --> class std::unordered_set<float, struct std::hash<float>, struct std::equal_to<float>, class std::allocator<float> > &", pybind11::return_value_policy::automatic, pybind11::arg(""));
		cl.def("get_allocator", (class std::allocator<float> (std::unordered_set<float>::*)() const) &std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::get_allocator, "C++: std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::get_allocator() const --> class std::allocator<float>");
		cl.def("empty", (bool (std::unordered_set<float>::*)() const) &std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::empty, "C++: std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::empty() const --> bool");
		cl.def("size", (unsigned long (std::unordered_set<float>::*)() const) &std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::size, "C++: std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::size() const --> unsigned long");
		cl.def("max_size", (unsigned long (std::unordered_set<float>::*)() const) &std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::max_size, "C++: std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::max_size() const --> unsigned long");
		cl.def("insert", (struct std::pair<struct std::__detail::_Node_iterator<float, true, false>, bool> (std::unordered_set<float>::*)(const float &)) &std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::insert, "C++: std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::insert(const float &) --> struct std::pair<struct std::__detail::_Node_iterator<float, true, false>, bool>", pybind11::arg("__x"));
		cl.def("erase", (unsigned long (std::unordered_set<float>::*)(const float &)) &std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::erase, "C++: std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::erase(const float &) --> unsigned long", pybind11::arg("__x"));
		cl.def("clear", (void (std::unordered_set<float>::*)()) &std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::clear, "C++: std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::clear() --> void");
		cl.def("swap", (void (std::unordered_set<float>::*)(class std::unordered_set<float, struct std::hash<float>, struct std::equal_to<float>, class std::allocator<float> > &)) &std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::swap, "C++: std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::swap(class std::unordered_set<float, struct std::hash<float>, struct std::equal_to<float>, class std::allocator<float> > &) --> void", pybind11::arg("__x"));
		cl.def("hash_function", (struct std::hash<float> (std::unordered_set<float>::*)() const) &std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::hash_function, "C++: std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::hash_function() const --> struct std::hash<float>");
		cl.def("key_eq", (struct std::equal_to<float> (std::unordered_set<float>::*)() const) &std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::key_eq, "C++: std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::key_eq() const --> struct std::equal_to<float>");
		cl.def("count", (unsigned long (std::unordered_set<float>::*)(const float &) const) &std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::count, "C++: std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::count(const float &) const --> unsigned long", pybind11::arg("__x"));
		cl.def("equal_range", (struct std::pair<struct std::__detail::_Node_iterator<float, true, false>, struct std::__detail::_Node_iterator<float, true, false> > (std::unordered_set<float>::*)(const float &)) &std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::equal_range, "C++: std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::equal_range(const float &) --> struct std::pair<struct std::__detail::_Node_iterator<float, true, false>, struct std::__detail::_Node_iterator<float, true, false> >", pybind11::arg("__x"));
		cl.def("bucket_count", (unsigned long (std::unordered_set<float>::*)() const) &std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::bucket_count, "C++: std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::bucket_count() const --> unsigned long");
		cl.def("max_bucket_count", (unsigned long (std::unordered_set<float>::*)() const) &std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::max_bucket_count, "C++: std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::max_bucket_count() const --> unsigned long");
		cl.def("bucket_size", (unsigned long (std::unordered_set<float>::*)(unsigned long) const) &std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::bucket_size, "C++: std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::bucket_size(unsigned long) const --> unsigned long", pybind11::arg("__n"));
		cl.def("bucket", (unsigned long (std::unordered_set<float>::*)(const float &) const) &std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::bucket, "C++: std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::bucket(const float &) const --> unsigned long", pybind11::arg("__key"));
		cl.def("load_factor", (float (std::unordered_set<float>::*)() const) &std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::load_factor, "C++: std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::load_factor() const --> float");
		cl.def("max_load_factor", (float (std::unordered_set<float>::*)() const) &std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::max_load_factor, "C++: std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::max_load_factor() const --> float");
		cl.def("max_load_factor", (void (std::unordered_set<float>::*)(float)) &std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::max_load_factor, "C++: std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::max_load_factor(float) --> void", pybind11::arg("__z"));
		cl.def("rehash", (void (std::unordered_set<float>::*)(unsigned long)) &std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::rehash, "C++: std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::rehash(unsigned long) --> void", pybind11::arg("__n"));
		cl.def("reserve", (void (std::unordered_set<float>::*)(unsigned long)) &std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::reserve, "C++: std::unordered_set<float, std::hash<float>, std::equal_to<float>, std::allocator<float> >::reserve(unsigned long) --> void", pybind11::arg("__n"));
	}
}


// File: T42_stl_names_set.cpp
#include <T42.stl.names.set.hpp> // foo
#include <deque> // std::deque
#include <forward_list> // std::forward_list
#include <functional> // std::equal_to
#include <functional> // std::hash
#include <functional> // std::less
#include <list> // std::list
#include <map> // std::_Rb_tree_const_iterator
#include <memory> // std::allocator
#include <set> // std::set
#include <unordered_map> // std::__detail::_Node_const_iterator
#include <unordered_map> // std::__detail::_Node_iterator
#include <unordered_set> // std::unordered_set
#include <utility> // std::pair
#include <vector> // std::vector

#include <functional>
#include <pybind11/pybind11.h>
#include <string>

#ifndef BINDER_PYBIND11_TYPE_CASTER
	#define BINDER_PYBIND11_TYPE_CASTER
	PYBIND11_DECLARE_HOLDER_TYPE(T, std::shared_ptr<T>)
	PYBIND11_DECLARE_HOLDER_TYPE(T, T*)
	PYBIND11_MAKE_OPAQUE(std::shared_ptr<void>)
#endif

void bind_T42_stl_names_set(std::function< pybind11::module &(std::string const &namespace_) > &M)
{
	// foo(class std::set<float, struct std::less<float>, class std::allocator<float> >) file:T42.stl.names.set.hpp line:
	M("").def("foo", (void (*)(class std::set<float, struct std::less<float>, class std::allocator<float> >)) &foo, "C++: foo(class std::set<float, struct std::less<float>, class std::allocator<float> >) --> void", pybind11::arg(""));

	// foo(class std::unordered_set<float, struct std::hash<float>, struct std::equal_to<float>, class std::allocator<float> >) file:T42.stl.names.set.hpp line:
	M("").def("foo", (void (*)(class std::unordered_set<float, struct std::hash<float>, struct std::equal_to<float>, class std::allocator<float> >)) &foo, "C++: foo(class std::unordered_set<float, struct std::hash<float>, struct std::equal_to<float>, class std::allocator<float> >) --> void", pybind11::arg(""));

	// foo(class std::set<class std::list<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > >, class std::allocator<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > > > >, struct std::less<class std::list<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > >, class std::allocator<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > > > > >, class std::allocator<class std::list<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > >, class std::allocator<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > > > > > >) file:T42.stl.names.set.hpp line:
	M("").def("foo", (void (*)(class std::set<class std::list<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > >, class std::allocator<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > > > >, struct std::less<class std::list<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > >, class std::allocator<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > > > > >, class std::allocator<class std::list<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > >, class std::allocator<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > > > > > >)) &foo, "C++: foo(class std::set<class std::list<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > >, class std::allocator<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > > > >, struct std::less<class std::list<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > >, class std::allocator<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > > > > >, class std::allocator<class std::list<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > >, class std::allocator<class std::forward_list<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > >, class std::allocator<class std::deque<class std::vector<double, class std::allocator<double> >, class std::allocator<class std::vector<double, class std::allocator<double> > > > > > > > > >) --> void", pybind11::arg(""));

}


#include <map>
#include <algorithm>
#include <functional>
#include <memory>
#include <stdexcept>
#include <string>

#include <pybind11/pybind11.h>

typedef std::function< pybind11::module & (std::string const &) > ModuleGetter;

void bind_std_stl_function(std::function< pybind11::module &(std::string const &namespace_) > &M);
void bind_std_functional_hash(std::function< pybind11::module &(std::string const &namespace_) > &M);
void bind_std_unordered_set(std::function< pybind11::module &(std::string const &namespace_) > &M);
void bind_T42_stl_names_set(std::function< pybind11::module &(std::string const &namespace_) > &M);


PYBIND11_MODULE(T42_stl_names_set, root_module) {
	root_module.doc() = "T42_stl_names_set module";

	std::map <std::string, pybind11::module> modules;
	ModuleGetter M = [&](std::string const &namespace_) -> pybind11::module & {
		auto it = modules.find(namespace_);
		if( it == modules.end() ) throw std::runtime_error("Attempt to access pybind11::module for namespace " + namespace_ + " before it was created!!!");
		return it->second;
	};

	modules[""] = root_module;

	static std::vector<std::string> const reserved_python_words {"nonlocal", "global", };

	auto mangle_namespace_name(
		[](std::string const &ns) -> std::string {
			if ( std::find(reserved_python_words.begin(), reserved_python_words.end(), ns) == reserved_python_words.end() ) return ns;
			else return ns+'_';
		}
	);

	std::vector< std::pair<std::string, std::string> > sub_modules {
		{"", "std"},
	};
	for(auto &p : sub_modules ) modules[p.first.size() ? p.first+"::"+p.second : p.second] = modules[p.first].def_submodule( mangle_namespace_name(p.second).c_str(), ("Bindings for " + p.first + "::" + p.second + " namespace").c_str() );

	//pybind11::class_<std::shared_ptr<void>>(M(""), "_encapsulated_data_");

	bind_std_stl_function(M);
	bind_std_functional_hash(M);
	bind_std_unordered_set(M);
	bind_T42_stl_names_set(M);

}

// Source list file: TEST/T42_stl_names_set.sources
// T42_stl_names_set.cpp
// std/stl_function.cpp
// std/functional_hash.cpp
// std/unordered_set.cpp
// T42_stl_names_set.cpp

// Modules list file: TEST/T42_stl_names_set.modules
// std 
